set term png
set output "PoseCompare.png"
set multiplot layout 4, 1
#
set ylabel "x-position"
plot "PoseROS.dat" using 1:2 with lines title "ROS", "PoseMORSE.dat" using 1:2 with lines title "MORSE"
#
set ylabel "y-position"
plot "PoseROS.dat" using 1:3 with lines title "ROS", "PoseMORSE.dat" using 1:3 with lines title "MORSE"
#
set ylabel "z-position"
plot "PoseROS.dat" using 1:4 with lines title "ROS", "PoseMORSE.dat" using 1:4 with lines title "MORSE"
#
set ylabel "yaw angle"
plot "PoseROS.dat" using 1:7 with lines title "ROS", "PoseMORSE.dat" using 1:7 with lines title "MORSE"
unset multiplot

set term png
set output "NuCompare.png"
set multiplot layout 4, 1
#
set ylabel "x-velocity"
plot "nu_ros.txt" using 1:2 with lines title "ROS", "nu_morse.txt" using 1:2 with lines title "MORSE"
#
set ylabel "y-Velocity"
plot "nu_ros.txt" using 1:3 with lines title "ROS", "nu_morse.txt" using 1:3 with lines title "MORSE"
#
set ylabel "z-Velocity"
plot "nu_ros.txt" using 1:4 with lines title "ROS", "nu_morse.txt" using 1:4 with lines title "MORSE"
#
set ylabel "yaw rate"
plot "nu_ros.txt" using 1:7 with lines title "ROS", "nu_morse.txt" using 1:7 with lines title "MORSE"
unset multiplot

set term png
set output "PitchRollCompare.png"
set multiplot layout 2, 1
#
set ylabel "Roll"
set yrange [-0.01:0.001]
plot "PoseROS.dat" using 1:5 with lines title "ROS", "PoseMORSE.dat" using 1:5 with lines title "MORSE"
#
set ylabel "Pitch"
plot "PoseROS.dat" using 1:6 with lines title "ROS", "PoseMORSE.dat" using 1:6 with lines title "MORSE"
unset multiplot

