#include "control/specifications.h"

float headingController(float heading_desired, float yaw_angle, float heading_integral, float yaw_rate)
{
  float P_gain=200;
  float D_gain=500;
  float I_gain=1;

  //Find heading error
  double headingError=yaw_angle-heading_desired;

  if (headingError>PI)
  {
    headingError=headingError-2*PI;
  }
  else if (headingError<-PI)
  {
    headingError=headingError+2*PI;
  }

  float heading_control;

  float P_control=headingError*P_gain;
  float D_control=yaw_rate*D_gain;
  float I_control=heading_integral*I_gain;

  float heading_force=-P_control-D_control-I_control;
  return heading_force;
}
