#include "control/specifications.h"

//TODO: read volume and mass, calculate buoyancy to include for better depth controller


//Thrust Allocation
Matrix<float, 6, Dynamic> getThrustAllocation(ifstream& specifications, int *nThrusters)
{
  specifications.open("inputFile.txt");

  if (!specifications)
  {
    ROS_INFO("Failed to open input file ");
    ros::shutdown();  //abort program
  }

  string dummy;
  Matrix<float, 6, Dynamic> T;


  //Ignoring first lines
  for(int i=0; i<41; i++)
  {
    specifications.ignore(10000, '\n'); 
  }
  specifications >> dummy;
  specifications.ignore(10000, '\n');
  specifications >> *nThrusters;
  ROS_INFO("%i thrusters registrated", *nThrusters);
  specifications.ignore(10000, '\n');

  T.resize(6, *nThrusters);
  
  getline(specifications, dummy);

  ROS_INFO("Reading thrust allocation matrix:");
  for (int i=0; i<6; i++)
  {
    cout << "\t";
    for(int j=0; j<*nThrusters; j++)
    {
          
      specifications >> T(i, j);
      cout << T(i, j) << "\t";    
    }
  cout << endl;
  }
  return T;
}

//Pose topic
string getPoseTopic(ifstream& specifications)
{
  for(int i=0; i<11; i++)
  {
    specifications.ignore(10000, '\n');  
  }

  string dummy, poseTopic;
  specifications.ignore(10000, '\n');  
  getline(specifications, dummy);
  specifications >> poseTopic;
  ROS_INFO("Subscribing pose topic for dynamics:  %s", poseTopic.c_str());
  return poseTopic;
}

//Velocity topic
string getTwistTopic(ifstream& specifications)
{

  string twistTopic;
  specifications.ignore(10000, '\n');  
  specifications >> twistTopic;
  ROS_INFO("Subscribing twist topic for dynamics:  %s", twistTopic.c_str());
  return twistTopic;
}
//Guidance
string getGuidanceTopic(ifstream& specifications)
{

  string dummy, guidanceTopic;
  specifications.ignore(10000, '\n');
  specifications.ignore(10000, '\n');
  specifications.ignore(10000, '\n');  
  getline(specifications, dummy);
  specifications >> guidanceTopic;
  ROS_INFO("Subscribing topic for guidance:  %s", guidanceTopic.c_str());
  
  return guidanceTopic;
}
