//Transforms euler angles from quaternions. 

#include "dynamics/specifications.h"

Vector3f eulerFromQuaternions(const Matrix<float, 4, 1>& quaternions)
{
  Matrix3f R_q;
  Vector3f euler;

  //Find rotation matrix R_q
  R_q=rotationMatrixQ(quaternions);

  //Find euler angles from rotation matrix (R_q ==R)
  euler(0)=atan2(R_q(2, 1), R_q(2, 2));
  euler(1)=-1*asin(R_q(2, 0));
  euler(2)=atan2(R_q(1, 0), R_q(0, 0));

  return euler;
}
