//Finds Inertia matrix about centre of orientation

#include "dynamics/specifications.h"

Matrix3f inertiaMatrix(const Matrix<float, 6, 6>& M_rb, const Vector3f& r_g)
{
  Matrix3f rg_skew, I_b;
  Vector3f r_gcopy;

  r_gcopy << r_g(0), r_g(1), r_g(2);

  //Find skew symmetric matrix of r_g
  rg_skew=skewSymmetric(r_gcopy);

  //Find Inertia matrix
  I_b=M_rb.bottomRightCorner(3, 3) - M_rb(0, 0)*rg_skew*rg_skew;

  return I_b;
}
