#include "dynamics/specifications.h"
//Fossen p 32
Matrix<float, 4, 1> quaternionsFromEuler(const Vector3f& euler)
{
  Matrix3f R;
  Matrix<float, 4, 1> quaternions;

  //Find rotation matrix R
  R=rotationMatrix(euler);

  //R44
  float R44 =R(0, 0)+R(1, 1)+R(2, 2);
  float p1, p2, p3, p4;
  if(R(0, 0)>=R(1, 1) && R(0, 0)>= R(2, 2) && R(0, 0) >=R44)
  {
    p1=abs(sqrt(1+2*R(0, 0)-R44));
    p4=(R(2, 1)-R(1, 2))/p1;
    p2=(R(0, 2)-R(2, 0))/p4;
    p3=(R(1, 0)-R(0, 1))/p4;
  } 
  else if(R(1, 1)>= R(2, 2) && R(1, 1) >=R44)
  {
    p2=abs(sqrt(1+2*R(1, 1)-R44));
    p4=(R(0, 2)-R(2, 0))/p2;
    p1=(R(2, 1)-R(1, 2))/p4;
    p3=(R(1, 0)-R(0, 1))/p4;    
  }
  else if(R(2, 2) >=R44)
  {
    p3=abs(sqrt(1+2*R(2, 2)-R44));
    p4=(R(1, 0)-R(0, 1))/p3;
    p2=(R(0, 2)-R(2, 0))/p4;
    p1=(R(2, 1)-R(1, 2))/p4; 
  }
  else
  {
    p4=abs(sqrt(1+R44));
    p2=(R(0, 2)-R(2, 0))/p4;
    p1=(R(2, 1)-R(1, 2))/p4; 
    p3=(R(1, 0)-R(0, 1))/p4; 
  }


  quaternions << p4/2, p1/2, p2/2, p3/2;

  return quaternions;
}
