#include "dynamics/specifications.h"

Matrix3f rotationMatrix(const Vector3f& euler)
{

  Matrix3f R, R_roll, R_pitch, R_yaw;

  R_roll << 1, 0, 0, 
            0, cos(euler(0)), -sin(euler(0)), 
            0, sin(euler(0)), cos(euler(0));

  R_pitch << cos(euler(1)), 0,  sin(euler(1)), 
            0, 1, 0, 
            -sin(euler(1)), 0,  cos(euler(1));

  R_yaw <<  cos(euler(2)), -sin(euler(2)), 0,  
            sin(euler(2)),  cos(euler(2)), 0, 
            0, 0, 1;


  R=R_yaw*R_pitch*R_roll;

  return R;
}
