#include "dynamics/specifications.h"



//Fossen p29
Matrix<float, 4, 3> transformationMatrixQ(const Matrix<float, 4, 1>& quaternions)
{
  Matrix<float, 4, 3> T_q;

  //qdot=T_q*omega
  T_q(0, 0)=-0.5*quaternions[1];
  T_q(0, 1)=-0.5*quaternions[2];
  T_q(0, 2)=-0.5*quaternions[3];

  T_q(1, 0)=0.5*quaternions[0];
  T_q(1, 1)=-0.5*quaternions[3];
  T_q(1, 2)=0.5*quaternions[2];

  T_q(2, 0)=0.5*quaternions[3];
  T_q(2, 1)=0.5*quaternions[0];
  T_q(2, 2)=-0.5*quaternions[1];

  T_q(3, 0)=-0.5*quaternions[2];
  T_q(3, 1)=0.5*quaternions[1];
  T_q(3, 2)=0.5*quaternions[0];
  
  return T_q;
}
