#include "dynamics/specifications.h"


Matrix<float, 6, 1> updateEta(const Matrix<float, 7, 1>& eta_q)
{
  Matrix<float, 6, 1> eta;

  //Get angles in euler from eta_q
  Matrix<float, 4, 1> quaternions; quaternions << eta_q(3), eta_q(4), eta_q(5), eta_q(6);
  
  //Find euler angles from quaternions
  Vector3f euler;
  euler=eulerFromQuaternions(quaternions);

  eta << eta_q.topRightCorner(3, 1), euler;

  return eta;
}

