#include "dynamics/specifications.h"


Matrix<float, 7, 1> updateEtaQ(const Matrix<float, 6, 1>& eta)
{
  Matrix<float, 7, 1> eta_q;

  //Get euler angles from eta
  Vector3f euler; euler << eta(3), eta(4), eta(5);
  
  //Find quaternions from euler angles
  Matrix<float, 4, 1> quaternions;
  quaternions=quaternionsFromEuler(euler);

  eta_q << eta.topRightCorner(3, 1), quaternions;

  return eta_q;

}

