#include "dynamics/specifications.h"


Matrix<float, 7, 1> updateEtaQdot(const Matrix<float, 7, 1>& eta_q, const Matrix<float, 6, 1>& nu)
{

  Matrix<float, 7, 1> eta_q_dot;
  Matrix<float, 4, 3> T_q;
  Matrix3f R_q;
  
  Matrix<float, 4, 1> quaternions;
  quaternions << eta_q(3), eta_q(4), eta_q(5), eta_q(6);

  //Find Rotation matrix R_q
  R_q = rotationMatrixQ(quaternions);


  //Find Transfomration matrix T_q
  T_q=transformationMatrixQ(quaternions);


  Vector3f v; v << nu(0), nu(1), nu(2);
  Vector3f omega; omega << nu(3), nu(4), nu(5);
  Vector3f p_dot;
  Matrix<float, 4, 1> q_dot;


  p_dot=R_q*v;
  q_dot=T_q*omega;


  eta_q_dot << p_dot, q_dot;

  return eta_q_dot;

}
