#include "dynamics/specifications.h"


//Fossen p60
Matrix<float, 6, 1> updateRestoring(float W, float B, const Matrix<float, 6, 1>& eta, const Vector3f& r_g, const Vector3f& r_b)
{

Matrix<float, 6, 1> G_restoring;

double sin_theta =sin(eta(4));
double cos_theta = cos(eta(4));
double sin_phi = sin(eta(3));
double cos_phi = cos(eta(3));


G_restoring(0)=(W-B)*sin_theta;
G_restoring(1)=-(W-B)*cos_theta*sin_phi;
G_restoring(2)=-(W-B)*cos_theta*cos_phi;
G_restoring(3)=-(r_g(1)*W-r_b(1)*B)*cos_theta*cos_phi+(r_g(2)*W-r_b(2)*B)*cos_theta*sin_phi;
G_restoring(4)=(r_g(2)*W-r_b(2)*B)*sin_theta+(r_g[0]*W-r_b(0)*B)*cos_theta*cos_phi;
G_restoring(5)=-(r_g(0)*W-r_b(0)*B)*cos_theta*sin_phi-(r_g(1)*W-r_b(1)*B)*sin_theta;


return G_restoring;
}
