#include <ros/ros.h>
#include <std_msgs/String.h>
#include <sstream>
#include <nav_msgs/Odometry.h>
#include <math.h>
#include <time.h>
#include <stdio.h>
#include <stdlib.h>
#include <vector>
#include "std_msgs/MultiArrayLayout.h"
#include "std_msgs/MultiArrayDimension.h"
#include "std_msgs/Int32MultiArray.h" 
#include "geometry_msgs/PoseStamped.h" 
#include "geometry_msgs/TwistStamped.h" 
#include <std_msgs/Float32.h>
#include "pathplanning/WayPoint.h"
#include <fstream>
#include <Eigen/Dense>
#include "guidance/headingGuidance.h"

using namespace Eigen;
using namespace std;


//Simulation timestep
float N=10;
double dt=1/N;

//Function declaration
Matrix<float, 6, 1> guidanceGetInitialEta(ifstream& specifications);
string guidanceGetTwistTopic(ifstream& specifications);
string guidanceGetPoseTopic(ifstream& specifications);
string guidanceGetPathInfo(ifstream& specifications, int *n);

Matrix<float, 6, 1> updateEta(const Matrix<float, 7, 1>& eta_q);
void updatePosition(const geometry_msgs::PoseStamped::ConstPtr& msg);
void updateVelocity(const geometry_msgs::TwistStamped::ConstPtr& msg);
void updateWP(const pathplanning::WayPoint::ConstPtr& msg);
void updateLOSmsg(guidance::headingGuidance* msg, float heading_desired, float depth_desired);

Matrix<float, Dynamic, 3> WPgeneration(string path_style, int n, const Matrix<float, 6, 1>& initialEta);
