#include "guidance/specifications.h"

Matrix<float, 6, 1> guidanceGetInitialEta(ifstream& specifications)
{

  specifications.open("inputFile.txt");

  if (!specifications)
  {
    ROS_INFO("Failed to open input file ");
    ros::shutdown();  //abort program
  }

  string dummy;
  Matrix<float, 6, 1> initialEta;
  
  specifications.ignore(1000,'\n');
  specifications.ignore(1000,'\n');
  getline(specifications, dummy);
  specifications.ignore(1000,'\n');
  specifications >> initialEta(0) >> initialEta(1) >> initialEta(2) >> initialEta(3) >> initialEta(4) >> initialEta(5);

  ROS_INFO("Initial pose of %s : (%.1f, %.1f, %.1f, %.1f, %.1f, %.1f)", dummy.c_str(), initialEta(0), initialEta(1), initialEta(2), initialEta(3), initialEta(4), initialEta(5));
  
  return initialEta;
}



string guidanceGetPoseTopic(ifstream& specifications)
{

  string dummy, poseTopic;
  for(int i=0; i<57; i++)
  {
    specifications.ignore(10000, '\n');  
  }  
  getline(specifications, dummy);
  specifications >> poseTopic;
  ROS_INFO("Subscribing pose topic for dynamics:  %s", poseTopic.c_str());
  
  return poseTopic;
}


string guidanceGetTwistTopic(ifstream& specifications)
{
  string twistTopic;
  specifications.ignore(10000, '\n');  
  specifications >> twistTopic;
  ROS_INFO("Subscribing twist topic for dynamics:  %s", twistTopic.c_str());
  
  return twistTopic;
}

string guidanceGetPathInfo(ifstream& specifications, int *n)
{
  string pathStyle;
  for(int i=0; i<6; i++)
  {
    specifications.ignore(10000, '\n');  
  }  
  specifications >> pathStyle;
  specifications.ignore(10000, '\n');
  specifications.ignore(10000, '\n');
  specifications >> *n;
  ROS_INFO("Path style chosen:  %s", pathStyle.c_str());
  ROS_INFO("Number of waypoints:  %i", *n);  

  return pathStyle;
}
