#include <ros/ros.h>
#include <std_msgs/String.h>
#include <sstream>
#include <nav_msgs/Odometry.h>
#include <math.h>
#include <time.h>
#include <stdio.h>
#include <stdlib.h>
#include <vector>
#include "std_msgs/MultiArrayLayout.h"
#include "std_msgs/MultiArrayDimension.h"
#include "std_msgs/Int32MultiArray.h" 
#include "pathplanning/WayPoint.h"
#include "geometry_msgs/PoseStamped.h" 
#include <Eigen/Dense>
#include <fstream>

using namespace Eigen;
using namespace std;

#define PI 3.14159265


//Simulation timestep
float N=10;
double dt=1/N;


//Function declaration
Matrix<float, Dynamic, 3> sinePath(int n, const Matrix<float, 6, 1>& initialEta);
Matrix<float, Dynamic, 3> spiralPath(int n, const Matrix<float, 6, 1>& initialEta);
Matrix<float, Dynamic, 3> lawnmowerPath(int n, const Matrix<float, 6, 1>& initialEta);
Matrix<float, Dynamic, 3> straightPath(int n, const Matrix<float, 6, 1>& initialEta);

string getDynamicsTopicWP(ifstream& specifications);
Matrix<float, 6, 1> getPosition(ifstream& specifications);
string getPathFollowingInfo(ifstream& specifications, int *n);


Matrix<float, Dynamic, 3> WPgeneration(string path_style, int n, const Matrix<float, 6, 1>& initialEta);

void updateWPmsg(pathplanning::WayPoint* msg, float WP[2][3]);
void updatePosition(const geometry_msgs::PoseStamped::ConstPtr& msg);
Matrix<float, 6, 1> updateEta(const Matrix<float, 7, 1>& eta_q);

