//For generation way points based on desired path style

#include "pathplanning/specifications.h"


Matrix<float, Dynamic, 3> WPgeneration(string path_style, int n, const Matrix<float, 6, 1>& initialEta)
{

  ROS_INFO("Starting waypoint generation");  

  Matrix<float, Dynamic, 3> WP;
  //WP.resize(n, 3);

  Matrix<float, 6, 1> initialEta_copy;
  initialEta_copy=initialEta;

  //Get way points
  if(path_style=="sine")
  {
    WP=sinePath(n, initialEta_copy);  
  }
  else if (path_style=="spiral")
  {
    WP=spiralPath(n, initialEta_copy);
  }
  else if (path_style=="lawn_mower")
  {
    WP=lawnmowerPath(n, initialEta_copy); 
  }
  else if (path_style=="straight")
  {
    WP=straightPath(n, initialEta_copy);
  }
  else
  {
    ROS_INFO("Path style not recognized, exiting");
    ros::shutdown();
  }

  return WP;
}
