#include "pathplanning/specifications.h"



Matrix<float, 6, 1> getPosition(ifstream& specifications)
{

  string dummy;
  Matrix<float, 6, 1> eta;

  //Open file
  specifications.open("inputFile.txt");
  if (!specifications)
  {
    ROS_INFO("Failed to open input file ");
    ros::shutdown();  //abort program
  }

  //ignoring first lines
  specifications.ignore(10000, '\n'); 
  specifications.ignore(10000, '\n'); 
  specifications.ignore(10000, '\n'); 


  //Read initial position
  getline(specifications, dummy);
  specifications >> eta(0) >> eta(1) >> eta(2) >> eta(3) >> eta(4) >> eta(5);
  ROS_INFO("Read initial eta: %.1f  %.1f  %.1f  %.1f  %.1f  %.1f", eta(0), eta(1), eta(2), eta(3), eta(4), eta(5));
  specifications.ignore(10000, '\n'); //Ignore rest of position line (empty)
  return eta;
}


string getDynamicsTopicWP(ifstream& specifications)
{

  string dummy, poseTopic;
  for(int i=0; i<56; i++)
  {
    specifications.ignore(10000, '\n');
  }
  getline(specifications, dummy);
  specifications >> poseTopic;
  ROS_INFO("Subscribing pose topic for dynamics:  %s", poseTopic.c_str());
  
specifications.ignore(10000, '\n');
  specifications.ignore(10000, '\n'); //Ignore twist path
  specifications.ignore(10000, '\n'); //Ignore controller topic
  specifications.ignore(10000, '\n');
  specifications.ignore(10000, '\n'); //Ignore guidance
  specifications.ignore(10000, '\n');
 
 return poseTopic;
}

string getPathFollowingInfo(ifstream& specifications, int *n)
{

  string dummy, path;
  getline(specifications, dummy);
  specifications >> path;
specifications.ignore(10000, '\n');
  getline(specifications, dummy);
  specifications >> *n;

  ROS_INFO("Path desired:  %s", path.c_str());
  ROS_INFO("Number of waypoinst:  %i", *n);
  
  return path;
}


