#include "pathplanning/specifications.h"


//Generates a lawn mower path based on initial position
Matrix<float, Dynamic, 3> lawnmowerPath(int n, const Matrix<float, 6, 1>& initialEta)
{
  //path specs
  float length=40;
  float b=10;

  //Distance between way-points in x-dir
  float lookAhead=2;

  //Coordinates of path beginning 
  float x0, y0, z0;
  x0=initialEta(0);
  y0=initialEta(1);
  z0=initialEta(2);

  //Waypoint vector
  Matrix<float, Dynamic, 3> WP;
  WP.resize(n, 3);


  //Calculate waypoint coordinates
  int i=0;
  float x, y, z;
  x=x0;
  y=y0;
  z=z0;
  bool forth=true;
  float turn=0.0;
  while(i<n)
  {  
    if ((y-y0)>=length && forth==true)
    {
      
      if (turn<(b-lookAhead))
      { //Dersom langs bredda
        x=x+lookAhead;
        forth=true;
        turn=turn+lookAhead;
      }
      else
      { //Dersom på nest siste
        forth=false;
        x=x+b-turn;
        turn=0;
      }

      //forth=true;
      //cout << "TEST1 " << endl;
    }
    else if (y<=y0 && forth==false)
    {

    if (turn<(b-lookAhead))
      { //Dersom langs bredda
        x=x+lookAhead;
        forth=false;
        turn=turn+lookAhead;
      }
      else
      { //Dersom på nest siste
        forth=true;
        x=x+b-turn;
        turn=0;
      }

      //x=x+b;
      //forth=true;
        //cout << "TEST2 " << endl;
    } 
    else
    {
      if (forth==true)
      {
        y=y+lookAhead;
      }
      else
      {
        y=y-lookAhead;
      }
    }

    WP(i, 0)=y;
    WP(i, 1)=x;
    WP(i, 2)=z0;
    i=i+1;
  }

  //cout << WP << endl;
  ROS_INFO("Lawn mower path generated for path following");
  return WP;
}
