#include "pathplanning/specifications.h"


//Generates a sine path based on initial position
Matrix<float, Dynamic, 3> sinePath(int n, const Matrix<float, 6, 1>& initialEta)
{
  //Sine path specs
  float lambda=10;
  float h=15;

  //Distance between way-points in x-dir
  float lookAhead=2;

  //Coordinates of path beginning 
  float x, y, z;
  x=initialEta(0);
  y=initialEta(1);
  z=initialEta(2);

  //Waypoint vector
  Matrix<float, Dynamic, 3> WP;
  WP.resize(n, 3);


  //Calculate waypoint coordinates
  for(int i=0; i<n; i++)
  {
    WP(i, 0)=x+i*lookAhead;
    WP(i, 1)=y+h*sin(i*lookAhead*2*PI/lambda);
    WP(i, 2)=z;
  }
  cout << WP << endl;

  ROS_INFO("Sine path generated for path following");
  return WP;
}
