#include "pathplanning/specifications.h"

Matrix<float, Dynamic, 3>  spiralPath(int n, const Matrix<float, 6, 1>& initialEta)
{
  
  //Spiral path specs
  float radius=20;
  float height=2;
  float lookAhead=2;

  //Coordinates of path beginning 
  float x, y, z;
  x=initialEta(0);
  y=initialEta(1);
  z=initialEta(2);


  //Waypint vector
  Matrix<float, Dynamic, 3> WP;
  WP.resize(n, 3);

  //Find coordinates for spiral
  float angle=0;
  int lap=0;
  for(int i=0; i<n; i++)
  {
    angle = angle + lookAhead/radius;
    while(angle>2*PI)
    {
      angle=angle-2*PI;
      lap=lap+1;
    }
    WP(i, 0)=x-radius+radius*cos(angle);
    WP(i, 1)=y+radius*sin(angle);
    WP(i, 2)=z-height*(lap+angle/(2*PI));
  }

  ROS_INFO("Spiral path generated for path following");
  return WP;

}
